# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from .. import deb as _deb
from .. import deletion
from .. import firedancer
from .. import firedancer as _firedancer
from .. import runner as _runner
from .. import solana as _solana
from .. import ssh as _ssh

__all__ = ['FiredancerArgs', 'Firedancer']

@pulumi.input_type
class FiredancerArgs:
    def __init__(__self__, *,
                 config: pulumi.Input['_firedancer.ConfigArgs'],
                 connection: pulumi.Input['_ssh.ConnectionArgs'],
                 key_pairs: pulumi.Input['_firedancer.KeyPairsArgs'],
                 deletion_policy: Optional[pulumi.Input['deletion.Policy']] = None,
                 environment: Optional[pulumi.Input['_solana.EnvironmentArgs']] = None,
                 runner_config: Optional[pulumi.Input['_runner.ConfigArgs']] = None,
                 variant: Optional[pulumi.Input['firedancer.Variant']] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a Firedancer resource.
        """
        pulumi.set(__self__, "config", config)
        pulumi.set(__self__, "connection", connection)
        pulumi.set(__self__, "key_pairs", key_pairs)
        if deletion_policy is not None:
            pulumi.set(__self__, "deletion_policy", deletion_policy)
        if environment is not None:
            pulumi.set(__self__, "environment", environment)
        if runner_config is not None:
            pulumi.set(__self__, "runner_config", runner_config)
        if variant is not None:
            pulumi.set(__self__, "variant", variant)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def config(self) -> pulumi.Input['_firedancer.ConfigArgs']:
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: pulumi.Input['_firedancer.ConfigArgs']):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['_ssh.ConnectionArgs']:
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['_ssh.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter(name="keyPairs")
    def key_pairs(self) -> pulumi.Input['_firedancer.KeyPairsArgs']:
        return pulumi.get(self, "key_pairs")

    @key_pairs.setter
    def key_pairs(self, value: pulumi.Input['_firedancer.KeyPairsArgs']):
        pulumi.set(self, "key_pairs", value)

    @property
    @pulumi.getter(name="deletionPolicy")
    def deletion_policy(self) -> Optional[pulumi.Input['deletion.Policy']]:
        return pulumi.get(self, "deletion_policy")

    @deletion_policy.setter
    def deletion_policy(self, value: Optional[pulumi.Input['deletion.Policy']]):
        pulumi.set(self, "deletion_policy", value)

    @property
    @pulumi.getter
    def environment(self) -> Optional[pulumi.Input['_solana.EnvironmentArgs']]:
        return pulumi.get(self, "environment")

    @environment.setter
    def environment(self, value: Optional[pulumi.Input['_solana.EnvironmentArgs']]):
        pulumi.set(self, "environment", value)

    @property
    @pulumi.getter(name="runnerConfig")
    def runner_config(self) -> Optional[pulumi.Input['_runner.ConfigArgs']]:
        return pulumi.get(self, "runner_config")

    @runner_config.setter
    def runner_config(self, value: Optional[pulumi.Input['_runner.ConfigArgs']]):
        pulumi.set(self, "runner_config", value)

    @property
    @pulumi.getter
    def variant(self) -> Optional[pulumi.Input['firedancer.Variant']]:
        return pulumi.get(self, "variant")

    @variant.setter
    def variant(self, value: Optional[pulumi.Input['firedancer.Variant']]):
        pulumi.set(self, "variant", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


@pulumi.type_token("svmkit:validator:Firedancer")
class Firedancer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[Union['_firedancer.ConfigArgs', '_firedancer.ConfigArgsDict']]] = None,
                 connection: Optional[pulumi.Input[Union['_ssh.ConnectionArgs', '_ssh.ConnectionArgsDict']]] = None,
                 deletion_policy: Optional[pulumi.Input['deletion.Policy']] = None,
                 environment: Optional[pulumi.Input[Union['_solana.EnvironmentArgs', '_solana.EnvironmentArgsDict']]] = None,
                 key_pairs: Optional[pulumi.Input[Union['_firedancer.KeyPairsArgs', '_firedancer.KeyPairsArgsDict']]] = None,
                 runner_config: Optional[pulumi.Input[Union['_runner.ConfigArgs', '_runner.ConfigArgsDict']]] = None,
                 variant: Optional[pulumi.Input['firedancer.Variant']] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a Firedancer resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FiredancerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Firedancer resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param FiredancerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FiredancerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[Union['_firedancer.ConfigArgs', '_firedancer.ConfigArgsDict']]] = None,
                 connection: Optional[pulumi.Input[Union['_ssh.ConnectionArgs', '_ssh.ConnectionArgsDict']]] = None,
                 deletion_policy: Optional[pulumi.Input['deletion.Policy']] = None,
                 environment: Optional[pulumi.Input[Union['_solana.EnvironmentArgs', '_solana.EnvironmentArgsDict']]] = None,
                 key_pairs: Optional[pulumi.Input[Union['_firedancer.KeyPairsArgs', '_firedancer.KeyPairsArgsDict']]] = None,
                 runner_config: Optional[pulumi.Input[Union['_runner.ConfigArgs', '_runner.ConfigArgsDict']]] = None,
                 variant: Optional[pulumi.Input['firedancer.Variant']] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FiredancerArgs.__new__(FiredancerArgs)

            if config is None and not opts.urn:
                raise TypeError("Missing required property 'config'")
            __props__.__dict__["config"] = config
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["deletion_policy"] = deletion_policy
            __props__.__dict__["environment"] = environment
            if key_pairs is None and not opts.urn:
                raise TypeError("Missing required property 'key_pairs'")
            __props__.__dict__["key_pairs"] = key_pairs
            __props__.__dict__["runner_config"] = runner_config
            __props__.__dict__["variant"] = variant
            __props__.__dict__["version"] = version
            __props__.__dict__["systemd_service_name"] = None
        super(Firedancer, __self__).__init__(
            'svmkit:validator:Firedancer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Firedancer':
        """
        Get an existing Firedancer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = FiredancerArgs.__new__(FiredancerArgs)

        __props__.__dict__["config"] = None
        __props__.__dict__["connection"] = None
        __props__.__dict__["deletion_policy"] = None
        __props__.__dict__["environment"] = None
        __props__.__dict__["key_pairs"] = None
        __props__.__dict__["runner_config"] = None
        __props__.__dict__["systemd_service_name"] = None
        __props__.__dict__["variant"] = None
        __props__.__dict__["version"] = None
        return Firedancer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output['_firedancer.outputs.Config']:
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['_ssh.outputs.Connection']:
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter(name="deletionPolicy")
    def deletion_policy(self) -> pulumi.Output[Optional['deletion.Policy']]:
        return pulumi.get(self, "deletion_policy")

    @property
    @pulumi.getter
    def environment(self) -> pulumi.Output[Optional['_solana.outputs.Environment']]:
        return pulumi.get(self, "environment")

    @property
    @pulumi.getter(name="keyPairs")
    def key_pairs(self) -> pulumi.Output['_firedancer.outputs.KeyPairs']:
        return pulumi.get(self, "key_pairs")

    @property
    @pulumi.getter(name="runnerConfig")
    def runner_config(self) -> pulumi.Output[Optional['_runner.outputs.Config']]:
        return pulumi.get(self, "runner_config")

    @property
    @pulumi.getter(name="systemdServiceName")
    def systemd_service_name(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "systemd_service_name")

    @property
    @pulumi.getter
    def variant(self) -> pulumi.Output[Optional['firedancer.Variant']]:
        return pulumi.get(self, "variant")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "version")

